#version 120

varying vec3 tintColor;

varying vec3 pos;

uniform vec3 upPosition;
uniform vec3 sunPosition;
uniform vec3 moonPosition;

uniform float frameTimeCounter;

uniform int worldTime;

#include "/lib/sky_gradient.glsl"

float timefract = worldTime;

float TimeSunrise  = ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0) + (1.0 - (clamp(timefract, 0.0, 4000.0)/4000.0));
float TimeNoon     = ((clamp(timefract, 0.0, 4000.0)) / 4000.0) - ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0);
float TimeSunset   = ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0) - ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0);
float TimeMidnight = ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0) - ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0);

#define getAngle(x) (0.7 / (x * x + 0.7))

void main() {
                 
	float mix_fog = getAngle(SkyGradient(upPosition, sunPosition, moonPosition, pos));

    vec3 noonSkyColor = vec3(0.5, 0.7, 1.0)*0.7;
	vec3 noonFogColor = vec3(0.5, 0.7, 1.0)*1.1;
	vec3 sunsetSkyColor = vec3(0.1, 0.7, 1.0)*0.9;
	vec3 sunsetNostalgia = vec3(0.5, 0.67, 0.9)*0.4;
	vec3 sunsetNostalgiaFog = vec3(0.9, 0.57, 0.1)*0.9;
	vec3 NostalgiaColor = vec3(0.1, 0.5, 1.0)*0.41;
	vec3 NostalgiaFogColor = vec3(0.1, 0.5, 1.0)*0.24;

	vec3 customSkyColor = (sunsetNostalgia*TimeSunrise + noonSkyColor*TimeNoon + sunsetNostalgia*TimeSunset + NostalgiaColor*TimeMidnight);
	vec3 customFogColor = (sunsetNostalgiaFog*TimeSunrise + noonFogColor*TimeNoon + sunsetNostalgiaFog*TimeSunset + NostalgiaFogColor*TimeMidnight);

/*DRAWBUFFERS:0*/
	gl_FragData[0] = vec4(tintColor, 1.0);
	gl_FragData[0].rgb = mix(customFogColor, customSkyColor, mix_fog);
}